import java.awt.TextArea;

/* RFID FixNumAdversary class: Simulate a RFID adversary that tries a fixed number as seed */
public class FixSeedAdversary extends RFIDCustomAdversary {

	public int seed;
	private TextArea ftext;
        private int fdisplayBitNumber;
        
	public FixSeedAdversary(int k, int n, int SenToAdrPort, String host, int AdvToVerPort,
                int displayBitNumber,
                int fseed, TextArea text) {
		super(k, n, SenToAdrPort, host, AdvToVerPort, text);
		seed = fseed;
                ftext = text;
                this.fdisplayBitNumber = displayBitNumber;
	}
	
	public boolean hack(int[] Y) {
		boolean result = true;
		
                int[] prs = RFIDCustom.createPseudoRandomArray(seed, Y.length, fdisplayBitNumber);		
		int[] Ydecrypt = RFIDCustom.xorArray(Y, prs);
		int[] keyWordInt = RFIDCustom.copyArray(Ydecrypt, Ydecrypt.length - RFIDCustom.kwOpen.length(), RFIDCustom.kwOpen.length());
		for (int i=0; result && i<keyWordInt.length; i++) {
			result = (char)(keyWordInt[i]) == RFIDCustom.kwOpen.charAt(i);
		}
		
		return result;
	}
}
