
import java.awt.Dimension;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.PrintStream;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.DefaultListModel;

public class MainForm extends javax.swing.JFrame {
    SettingsDialog settings;
    TestReportDialog testReport;
    boolean details = false;
    boolean cheat = false;
    
    private RFIDAP1UngenerlizedTag ap1_ung_tag;
    private RFIDAP1UngenerlizedVerifier ap1_ung_verifier;

    private RFIDAP1GenerlizedTag ap1_gen_tag;
    private RFIDAP1GenerlizedVerifier ap1_gen_verifier;
    
    private RFIDAP2UngenerlizedTag ap2_ung_tag;
    private RFIDAP2UngenerlizedVerifier ap2_ung_verifier;

    private RFIDAP2GenerlizedTag ap2_gen_tag;
    private RFIDAP2GenerlizedVerifier ap2_gen_verifier;
    
    private FixSeedAdversary adversary;
    
    public int n;
    public int k = 0;
    public int protocol;
    public int TagAdvPort;
    public int AdvVerPort;
    public int delayFactor;
    public int displayType;
    public int displayBitNumber;
    public String host;
    
    public MainForm() {
        initComponents();
        this.rootPane.setDefaultButton(StartButton);        
    }
    
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jFrame1 = new javax.swing.JFrame();
        StartButton = new javax.swing.JButton();
        TagPanel = new javax.swing.JPanel();
        jScrollPane3 = new javax.swing.JScrollPane();
        TagLRVList = new javax.swing.JList();
        jScrollPane6 = new javax.swing.JScrollPane();
        TagARVList = new javax.swing.JList();
        jLabel1 = new javax.swing.JLabel();
        jLabel9 = new javax.swing.JLabel();
        TagSendButton = new javax.swing.JButton();
        jLabel6 = new javax.swing.JLabel();
        VerifierMsgLabel = new javax.swing.JLabel();
        TagSeedLabel = new javax.swing.JLabel();
        jScrollPane8 = new javax.swing.JScrollPane();
        TagPrsList = new javax.swing.JList();
        jLabel12 = new javax.swing.JLabel();
        TagKeyEntryLabel = new javax.swing.JLabel();
        jScrollPane9 = new javax.swing.JScrollPane();
        TagYList = new javax.swing.JList();
        jLabel14 = new javax.swing.JLabel();
        TagText = new java.awt.TextArea();
        jLabel100 = new javax.swing.JLabel();
        jLabel17 = new javax.swing.JLabel();
        TagTestSessionButton = new javax.swing.JButton();
        TagImageLabel = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jPanel1 = new javax.swing.JPanel();
        VerifierPanel = new javax.swing.JPanel();
        jScrollPane5 = new javax.swing.JScrollPane();
        VerifierARVList = new javax.swing.JList();
        jLabel3 = new javax.swing.JLabel();
        jLabel10 = new javax.swing.JLabel();
        jScrollPane10 = new javax.swing.JScrollPane();
        VerifierZList = new javax.swing.JList();
        jLabel15 = new javax.swing.JLabel();
        jScrollPane11 = new javax.swing.JScrollPane();
        VerifierPrsList = new javax.swing.JList();
        jLabel13 = new javax.swing.JLabel();
        VerifierSeedLabel = new javax.swing.JLabel();
        VerifierKeyEntryLabel = new javax.swing.JLabel();
        VerifierText = new java.awt.TextArea();
        jLabel19 = new javax.swing.JLabel();
        jLabel101 = new javax.swing.JLabel();
        jPanel2 = new javax.swing.JPanel();
        jLabel4 = new javax.swing.JLabel();
        VerifierImageLabel = new javax.swing.JLabel();
        jScrollPane7 = new javax.swing.JScrollPane();
        VerifierLRVList = new javax.swing.JList();
        AdverseryPanel = new javax.swing.JPanel();
        AdversaryText = new java.awt.TextArea();
        jLabel5 = new javax.swing.JLabel();
        AdvHackMsgText = new javax.swing.JTextField();
        AdvTryToBreakInButton = new javax.swing.JButton();
        TagImageLabel1 = new javax.swing.JLabel();
        ChaetToggleButton = new javax.swing.JToggleButton();
        StopButton = new javax.swing.JButton();
        jToolBar1 = new javax.swing.JToolBar();
        TitleBackLabel = new javax.swing.JLabel();
        TitleForeLabel = new javax.swing.JLabel();
        DetailsButton = new javax.swing.JButton();
        jLabel7 = new javax.swing.JLabel();

        javax.swing.GroupLayout jFrame1Layout = new javax.swing.GroupLayout(jFrame1.getContentPane());
        jFrame1.getContentPane().setLayout(jFrame1Layout);
        jFrame1Layout.setHorizontalGroup(
            jFrame1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 400, Short.MAX_VALUE)
        );
        jFrame1Layout.setVerticalGroup(
            jFrame1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 300, Short.MAX_VALUE)
        );

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("RFID Simulation");
        setBounds(new java.awt.Rectangle(0, 0, 0, 0));
        setMinimumSize(new java.awt.Dimension(920, 820));
        getContentPane().setLayout(null);

        StartButton.setText("Start");
        StartButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                StartButtonActionPerformed(evt);
            }
        });
        getContentPane().add(StartButton);
        StartButton.setBounds(710, 20, 74, 23);

        TagPanel.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Tag", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Tahoma", 1, 11))); // NOI18N
        TagPanel.setLayout(null);

        TagLRVList.setEnabled(false);
        jScrollPane3.setViewportView(TagLRVList);

        TagPanel.add(jScrollPane3);
        jScrollPane3.setBounds(380, 40, 123, 160);

        TagARVList.setEnabled(false);
        jScrollPane6.setViewportView(TagARVList);

        TagPanel.add(jScrollPane6);
        jScrollPane6.setBounds(120, 40, 120, 160);

        jLabel1.setText("ARV:");
        TagPanel.add(jLabel1);
        jLabel1.setBounds(120, 20, 123, 14);

        jLabel9.setText("LRV:");
        TagPanel.add(jLabel9);
        jLabel9.setBounds(380, 20, 123, 14);

        TagSendButton.setText("Send");
        TagSendButton.setEnabled(false);
        TagSendButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                TagSendButtonActionPerformed(evt);
            }
        });
        TagPanel.add(TagSendButton);
        TagSendButton.setBounds(770, 40, 110, 23);

        jLabel6.setText("Verifier message:");
        TagPanel.add(jLabel6);
        jLabel6.setBounds(770, 130, 110, 14);

        VerifierMsgLabel.setFont(new java.awt.Font("Tahoma", 1, 14));
        VerifierMsgLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        VerifierMsgLabel.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        VerifierMsgLabel.setEnabled(false);
        TagPanel.add(VerifierMsgLabel);
        VerifierMsgLabel.setBounds(770, 150, 110, 30);

        TagSeedLabel.setEnabled(false);
        TagSeedLabel.setHorizontalTextPosition(javax.swing.SwingConstants.RIGHT);
        TagPanel.add(TagSeedLabel);
        TagSeedLabel.setBounds(270, 130, 100, 20);

        TagPrsList.setEnabled(false);
        jScrollPane8.setViewportView(TagPrsList);

        TagPanel.add(jScrollPane8);
        jScrollPane8.setBounds(510, 40, 120, 160);

        jLabel12.setText("prs:");
        TagPanel.add(jLabel12);
        jLabel12.setBounds(510, 20, 120, 14);

        TagKeyEntryLabel.setText("????????");
        TagKeyEntryLabel.setEnabled(false);
        TagPanel.add(TagKeyEntryLabel);
        TagKeyEntryLabel.setBounds(270, 70, 100, 14);

        TagYList.setEnabled(false);
        jScrollPane9.setViewportView(TagYList);

        TagPanel.add(jScrollPane9);
        jScrollPane9.setBounds(640, 40, 120, 160);

        jLabel14.setText("Y:");
        TagPanel.add(jLabel14);
        jLabel14.setBounds(640, 20, 120, 14);

        TagText.setEnabled(false);
        TagPanel.add(TagText);
        TagText.setBounds(910, 40, 200, 140);

        jLabel100.setText("Seed:");
        TagPanel.add(jLabel100);
        jLabel100.setBounds(260, 110, 110, 14);

        jLabel17.setText("Key Entry:");
        TagPanel.add(jLabel17);
        jLabel17.setBounds(260, 50, 110, 14);

        TagTestSessionButton.setText("Test session");
        TagTestSessionButton.setEnabled(false);
        TagTestSessionButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                TagTestSessionButtonActionPerformed(evt);
            }
        });
        TagPanel.add(TagTestSessionButton);
        TagTestSessionButton.setBounds(770, 80, 110, 23);

        TagImageLabel.setIcon(new javax.swing.ImageIcon(getClass().getResource("/RFIDTag2.small.JPG"))); // NOI18N
        TagPanel.add(TagImageLabel);
        TagImageLabel.setBounds(15, 50, 95, 95);

        jLabel2.setText("Communication:");
        TagPanel.add(jLabel2);
        jLabel2.setBounds(910, 20, 190, 14);

        jPanel1.setBorder(javax.swing.BorderFactory.createEtchedBorder(javax.swing.border.EtchedBorder.RAISED));

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 0, Short.MAX_VALUE)
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 156, Short.MAX_VALUE)
        );

        TagPanel.add(jPanel1);
        jPanel1.setBounds(895, 20, 2, 160);

        getContentPane().add(TagPanel);
        TagPanel.setBounds(10, 50, 890, 210);

        VerifierPanel.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Verifier", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Tahoma", 1, 11))); // NOI18N
        VerifierPanel.setLayout(null);

        VerifierARVList.setEnabled(false);
        jScrollPane5.setViewportView(VerifierARVList);

        VerifierPanel.add(jScrollPane5);
        jScrollPane5.setBounds(120, 40, 120, 160);

        jLabel3.setText("ARV:");
        VerifierPanel.add(jLabel3);
        jLabel3.setBounds(120, 20, 120, 14);

        jLabel10.setText("LRV:");
        VerifierPanel.add(jLabel10);
        jLabel10.setBounds(380, 20, 120, 14);

        VerifierZList.setEnabled(false);
        jScrollPane10.setViewportView(VerifierZList);

        VerifierPanel.add(jScrollPane10);
        jScrollPane10.setBounds(640, 40, 120, 160);

        jLabel15.setText("Z:");
        VerifierPanel.add(jLabel15);
        jLabel15.setBounds(640, 20, 120, 14);

        VerifierPrsList.setEnabled(false);
        jScrollPane11.setViewportView(VerifierPrsList);

        VerifierPanel.add(jScrollPane11);
        jScrollPane11.setBounds(510, 40, 120, 160);

        jLabel13.setText("prs:");
        VerifierPanel.add(jLabel13);
        jLabel13.setBounds(510, 20, 120, 14);

        VerifierSeedLabel.setEnabled(false);
        VerifierPanel.add(VerifierSeedLabel);
        VerifierSeedLabel.setBounds(270, 130, 100, 20);

        VerifierKeyEntryLabel.setText("??????");
        VerifierKeyEntryLabel.setEnabled(false);
        VerifierPanel.add(VerifierKeyEntryLabel);
        VerifierKeyEntryLabel.setBounds(270, 70, 100, 14);

        VerifierText.setEnabled(false);
        VerifierPanel.add(VerifierText);
        VerifierText.setBounds(910, 40, 200, 140);

        jLabel19.setText("Key Entry:");
        VerifierPanel.add(jLabel19);
        jLabel19.setBounds(260, 50, 110, 14);

        jLabel101.setText("Seed:");
        VerifierPanel.add(jLabel101);
        jLabel101.setBounds(260, 110, 110, 14);

        jPanel2.setBorder(javax.swing.BorderFactory.createEtchedBorder(javax.swing.border.EtchedBorder.RAISED));

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 0, Short.MAX_VALUE)
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 156, Short.MAX_VALUE)
        );

        VerifierPanel.add(jPanel2);
        jPanel2.setBounds(895, 20, 2, 160);

        jLabel4.setText("Communication:");
        VerifierPanel.add(jLabel4);
        jLabel4.setBounds(910, 20, 190, 14);

        VerifierImageLabel.setIcon(new javax.swing.ImageIcon(getClass().getResource("/Car2.small.JPG"))); // NOI18N
        VerifierPanel.add(VerifierImageLabel);
        VerifierImageLabel.setBounds(4, 50, 115, 95);

        VerifierLRVList.setEnabled(false);
        jScrollPane7.setViewportView(VerifierLRVList);

        VerifierPanel.add(jScrollPane7);
        jScrollPane7.setBounds(380, 40, 120, 160);

        getContentPane().add(VerifierPanel);
        VerifierPanel.setBounds(10, 540, 890, 210);

        AdverseryPanel.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Adversary", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Tahoma", 1, 11))); // NOI18N
        AdverseryPanel.setLayout(null);
        AdverseryPanel.add(AdversaryText);
        AdversaryText.setBounds(120, 60, 760, 160);

        jLabel5.setText("Adversary message (in decimal):");
        AdverseryPanel.add(jLabel5);
        jLabel5.setBounds(20, 30, 200, 14);

        AdvHackMsgText.setEnabled(false);
        AdvHackMsgText.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusGained(java.awt.event.FocusEvent evt) {
                GainFocus(evt);
            }
        });
        AdverseryPanel.add(AdvHackMsgText);
        AdvHackMsgText.setBounds(230, 30, 470, 20);

        AdvTryToBreakInButton.setText("Break in");
        AdvTryToBreakInButton.setEnabled(false);
        AdvTryToBreakInButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                AdvTryToBreakInButtonActionPerformed(evt);
            }
        });
        AdverseryPanel.add(AdvTryToBreakInButton);
        AdvTryToBreakInButton.setBounds(710, 30, 90, 23);

        TagImageLabel1.setIcon(new javax.swing.ImageIcon(getClass().getResource("/theif2.small.JPG"))); // NOI18N
        TagImageLabel1.setOpaque(true);
        AdverseryPanel.add(TagImageLabel1);
        TagImageLabel1.setBounds(10, 80, 95, 95);

        ChaetToggleButton.setText("cheat");
        ChaetToggleButton.setEnabled(false);
        ChaetToggleButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ChaetToggleButtonActionPerformed(evt);
            }
        });
        AdverseryPanel.add(ChaetToggleButton);
        ChaetToggleButton.setBounds(805, 30, 70, 23);

        getContentPane().add(AdverseryPanel);
        AdverseryPanel.setBounds(10, 280, 890, 240);

        StopButton.setText("Stop");
        StopButton.setEnabled(false);
        StopButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                StopButtonActionPerformed(evt);
            }
        });
        getContentPane().add(StopButton);
        StopButton.setBounds(630, 20, 74, 23);

        jToolBar1.setFloatable(false);
        jToolBar1.setRollover(true);
        getContentPane().add(jToolBar1);
        jToolBar1.setBounds(8, 476, 2, 2);

        TitleBackLabel.setFont(new java.awt.Font("Tahoma", 1, 18));
        TitleBackLabel.setForeground(new java.awt.Color(0, 153, 255));
        TitleBackLabel.setText("RFID Authentication Simulation");
        getContentPane().add(TitleBackLabel);
        TitleBackLabel.setBounds(21, 11, 286, 22);

        TitleForeLabel.setFont(new java.awt.Font("Tahoma", 1, 18));
        TitleForeLabel.setForeground(new java.awt.Color(0, 51, 204));
        TitleForeLabel.setText("RFID Authentication Simulation");
        getContentPane().add(TitleForeLabel);
        TitleForeLabel.setBounds(20, 10, 286, 22);

        DetailsButton.setText("Details ->");
        DetailsButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                DetailsButtonActionPerformed(evt);
            }
        });
        getContentPane().add(DetailsButton);
        DetailsButton.setBounds(810, 20, 90, 23);

        jLabel7.setFont(new java.awt.Font("Tahoma", 1, 11));
        jLabel7.setText("writened by Roi Tzaig 2008");
        getContentPane().add(jLabel7);
        jLabel7.setBounds(10, 760, 870, 14);

        pack();
    }// </editor-fold>//GEN-END:initComponents
    
    private void StartButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_StartButtonActionPerformed
        settings = new SettingsDialog(this, true);
        settings.show();
        
        if (!settings.get_result()) return;

        n                = settings.get_n();
        protocol         = settings.get_Protocol();
        delayFactor      = settings.get_delayFactor();
        displayType      = settings.get_DisplayType();
        displayBitNumber = settings.get_BitNumber();
        host             = settings.get_host();
        TagAdvPort       = settings.get_TagAdvPort();
        AdvVerPort       = settings.get_AdvVerPort();
        
        StartButton.setEnabled(false);
        StopButton.setEnabled(true);
        
        int[] ARV = RFIDCustom.createPseudoRandomArray(876, n, displayBitNumber);
        
        switch (protocol) {
            case RFIDCustom.PROTOCOL_AP1_UNGENERLIZED:
                k = 1;
                ap1_ung_verifier = new RFIDAP1UngenerlizedVerifier(AdvVerPort, ARV,
                        delayFactor, displayType, displayBitNumber,
                    VerifierText, 
                    VerifierARVList, VerifierLRVList,
                    VerifierZList,
                    VerifierKeyEntryLabel);
                adversary = new FixSeedAdversary(k, n, TagAdvPort, host, AdvVerPort, displayBitNumber,
                    123, AdversaryText);        
                ap1_ung_tag = new RFIDAP1UngenerlizedTag(host, TagAdvPort, ARV,
                    delayFactor, displayType, displayBitNumber,
                    TagText,
                    TagARVList, TagLRVList, TagYList,
                    TagKeyEntryLabel,
                    VerifierMsgLabel);
                break;
            case RFIDCustom.PROTOCOL_AP1_GENERLIZED:
                k = settings.get_AP1k();
                ap1_gen_verifier = new RFIDAP1GenerlizedVerifier(AdvVerPort, ARV,
                    delayFactor, displayType, displayBitNumber,
                    VerifierText, 
                    VerifierARVList, VerifierLRVList,
                    VerifierZList,
                    VerifierKeyEntryLabel);
                adversary = new FixSeedAdversary(k, n, TagAdvPort, host, AdvVerPort, displayBitNumber,
                    123, AdversaryText);        
                ap1_gen_tag = new RFIDAP1GenerlizedTag(host, TagAdvPort, ARV,
                    delayFactor, displayType, displayBitNumber,
                    TagText,
                    TagARVList, TagLRVList, TagYList,
                    TagKeyEntryLabel,
                    VerifierMsgLabel);
                break;
            case RFIDCustom.PROTOCOL_AP2_UNGENERLIZED:
                k = 1;
                ap2_ung_verifier = new RFIDAP2UngenerlizedVerifier(AdvVerPort, ARV,
                    delayFactor, displayType, displayBitNumber,
                    VerifierText, 
                    VerifierARVList, VerifierLRVList, VerifierPrsList, VerifierZList,
                    VerifierSeedLabel, VerifierKeyEntryLabel);
                adversary = new FixSeedAdversary(k, n, TagAdvPort, host, AdvVerPort, displayBitNumber,
                    123, AdversaryText);        
                ap2_ung_tag = new RFIDAP2UngenerlizedTag(host, TagAdvPort, ARV,
                    delayFactor, displayType, displayBitNumber,
                    TagText,
                    TagARVList, TagLRVList, TagPrsList, TagYList,
                    TagSeedLabel, TagKeyEntryLabel,
                    VerifierMsgLabel);
                break;
            case RFIDCustom.PROTOCOL_AP2_GENERLIZED:
                k = settings.get_AP2k();
                ap2_gen_verifier = new RFIDAP2GenerlizedVerifier(AdvVerPort, ARV,
                    delayFactor, displayType, displayBitNumber,
                    VerifierText, 
                    VerifierARVList, VerifierLRVList,
                    VerifierPrsList, VerifierZList,
                    VerifierSeedLabel, VerifierKeyEntryLabel);
                adversary = new FixSeedAdversary(k, n, TagAdvPort, host, AdvVerPort, displayBitNumber,
                    123, AdversaryText);        
                ap2_gen_tag = new RFIDAP2GenerlizedTag(host, TagAdvPort, ARV,
                    delayFactor, displayType, displayBitNumber,
                    TagText,
                    TagARVList, TagLRVList, TagPrsList, TagYList,
                    TagSeedLabel, TagKeyEntryLabel,
                    VerifierMsgLabel);
                break;
        }
        
        // enabling tag comopnents
        TagARVList.setEnabled(true);
        TagLRVList.setEnabled(true);
        TagPrsList.setEnabled(true);
        TagSeedLabel.setEnabled(true);
        TagKeyEntryLabel.setEnabled(true);
        TagYList.setEnabled(true);
        TagText.setEnabled(true);       
        TagSendButton.setEnabled(true);
        TagTestSessionButton.setEnabled(true);
        VerifierMsgLabel.setEnabled(true);
        
        // enabling Adversary comopnents
        AdversaryText.setEnabled(true);
        AdvHackMsgText.setEnabled(true);
        AdvTryToBreakInButton.setEnabled(true);
        ChaetToggleButton.setEnabled(true);
        
        // enabling Verifier comopnents
        VerifierARVList.setEnabled(true);
        VerifierLRVList.setEnabled(true);
        VerifierPrsList.setEnabled(true);
        VerifierSeedLabel.setEnabled(true);
        VerifierKeyEntryLabel.setEnabled(true);
        VerifierZList.setEnabled(true);
        VerifierText.setEnabled(true);
}//GEN-LAST:event_StartButtonActionPerformed

    private void TagSendButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_TagSendButtonActionPerformed
        switch (protocol) {
            case RFIDCustom.PROTOCOL_AP1_UNGENERLIZED:
                ap1_ung_tag.send(RFIDCustom.kwOpen);
                break;
            case RFIDCustom.PROTOCOL_AP1_GENERLIZED:
                ap1_gen_tag.send(RFIDCustom.kwOpen);
                break;
            case RFIDCustom.PROTOCOL_AP2_UNGENERLIZED:
                ap2_ung_tag.send(RFIDCustom.kwOpen);
                break;
            case RFIDCustom.PROTOCOL_AP2_GENERLIZED:
                ap2_gen_tag.send(RFIDCustom.kwOpen);
                break;
        }
}//GEN-LAST:event_TagSendButtonActionPerformed

    private void StopButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_StopButtonActionPerformed
        try {
            switch (protocol) {
            case RFIDCustom.PROTOCOL_AP1_UNGENERLIZED:
                ap1_ung_tag.close();
                adversary.close();
                ap1_ung_verifier.close();
                break;
            case RFIDCustom.PROTOCOL_AP1_GENERLIZED:
                ap1_gen_tag.close();
                adversary.close();
                ap1_gen_verifier.close();
                break;
            case RFIDCustom.PROTOCOL_AP2_UNGENERLIZED:
                ap2_ung_tag.close();
                adversary.close();
                ap2_ung_verifier.close();
                break;
            case RFIDCustom.PROTOCOL_AP2_GENERLIZED:
                ap2_gen_tag.close();
                adversary.close();
                ap2_gen_verifier.close();
                break;
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        StopButton.setEnabled(false);
        StartButton.setEnabled(true);
        
        // enabling tag comopnents
        TagARVList.setEnabled(false);
        TagARVList.setModel(new DefaultListModel());
        TagLRVList.setEnabled(false);
        TagLRVList.setModel(new DefaultListModel());
        TagPrsList.setEnabled(false);
        TagPrsList.setModel(new DefaultListModel());
        TagSeedLabel.setEnabled(false);
        TagSeedLabel.setText("");
        TagKeyEntryLabel.setEnabled(false);
        TagKeyEntryLabel.setText("");
        TagYList.setEnabled(false);
        TagYList.setModel(new DefaultListModel());
        TagText.setEnabled(false);
        TagText.setText("");
        TagSendButton.setEnabled(false);
        TagTestSessionButton.setEnabled(false);
        VerifierMsgLabel.setEnabled(false);
        VerifierMsgLabel.setText("");

        // enabling Adversary comopnents
        AdversaryText.setEnabled(false);
        AdversaryText.setText("");
        AdvHackMsgText.setEnabled(false);
        AdvHackMsgText.setText("");
        AdvTryToBreakInButton.setEnabled(false);
        ChaetToggleButton.setEnabled(false);

        // enabling Verifier comopnents
        VerifierARVList.setEnabled(false);
        VerifierARVList.setModel(new DefaultListModel());
        VerifierLRVList.setEnabled(false);
        VerifierLRVList.setModel(new DefaultListModel());
        VerifierPrsList.setEnabled(false);
        VerifierPrsList.setModel(new DefaultListModel());
        VerifierSeedLabel.setEnabled(false);
        VerifierSeedLabel.setText("");
        VerifierKeyEntryLabel.setEnabled(false);
        VerifierKeyEntryLabel.setText("");
        VerifierZList.setEnabled(false);
        VerifierZList.setModel(new DefaultListModel());      
        VerifierText.setEnabled(false);
        VerifierText.setText("");
    }//GEN-LAST:event_StopButtonActionPerformed

private void TagTestSessionButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_TagTestSessionButtonActionPerformed
    int[] TagARVSnapShot = null;
    switch (protocol) {
        case RFIDCustom.PROTOCOL_AP1_UNGENERLIZED:
            TagARVSnapShot = ap1_ung_tag.getARV().clone();
            break;
        case RFIDCustom.PROTOCOL_AP1_GENERLIZED:
            TagARVSnapShot = ap1_gen_tag.getARV().clone();
            break;
        case RFIDCustom.PROTOCOL_AP2_UNGENERLIZED:
            TagARVSnapShot = ap2_ung_tag.getARV().clone();
            break;
        case RFIDCustom.PROTOCOL_AP2_GENERLIZED:
            TagARVSnapShot = ap2_gen_tag.getARV().clone();
            break;
    }
    
    for (int i=0; i<n; i++) {
        TagSendButtonActionPerformed(evt);
    }
    
    int[] TagNewARV = null;
    switch (protocol) {
        case RFIDCustom.PROTOCOL_AP1_UNGENERLIZED:
            TagNewARV = ap1_ung_tag.getARV().clone();
            break;
        case RFIDCustom.PROTOCOL_AP1_GENERLIZED:
            TagNewARV = ap1_gen_tag.getARV().clone();
            break;
        case RFIDCustom.PROTOCOL_AP2_UNGENERLIZED:
            TagNewARV = ap2_ung_tag.getARV().clone();
            break;
        case RFIDCustom.PROTOCOL_AP2_GENERLIZED:
            TagNewARV = ap2_gen_tag.getARV().clone();
            break;
    }
    
    DefaultListModel mlOld = new DefaultListModel();
    DefaultListModel mlNew = new DefaultListModel();
    int CountUnchanged = 0;
    for (int i=0; i<n; i++) {
        if (TagARVSnapShot[i] == TagNewARV[i]) {
            mlOld.addElement(TagARVSnapShot[i] + " Not Changed");
            mlNew.addElement(TagNewARV[i] + " Not Changed");
            CountUnchanged++;
        } else {
            mlOld.addElement(TagARVSnapShot[i] + "");
            mlNew.addElement(TagNewARV[i] + "");
        }        
    }
    
    testReport = new TestReportDialog(this, true);
    testReport.setOldARVList(mlOld);
    testReport.setNewARVList(mlNew);
    testReport.setChangedCount(n - CountUnchanged);
    testReport.setUnchangedCount(CountUnchanged);
    testReport.show();
}//GEN-LAST:event_TagTestSessionButtonActionPerformed

private void AdvTryToBreakInButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_AdvTryToBreakInButtonActionPerformed
    if (adversary.userHack(AdvHackMsgText.getText()))
        AdversaryText.append("\n!!!! You broke in, the car is yours !!!!!\n");
    else
        AdversaryText.append("\nYou faild to break in, police men are on thier way...\n");
}//GEN-LAST:event_AdvTryToBreakInButtonActionPerformed

private void DetailsButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_DetailsButtonActionPerformed
    if (details) {
        this.setMinimumSize(new Dimension(920, this.getHeight()));
        this.setBounds(this.getX(), this.getY(), 920, this.getHeight());
        TagPanel.setBounds(TagPanel.getX(), TagPanel.getY(), 920-26, TagPanel.getHeight());

        AdverseryPanel.setBounds(AdverseryPanel.getX(), AdverseryPanel.getY(), 920-26, AdverseryPanel.getHeight());
        AdvHackMsgText.setBounds(AdvHackMsgText.getX(), AdvHackMsgText.getY(), AdvHackMsgText.getWidth()-220, AdvHackMsgText.getHeight());
        AdversaryText.setBounds(AdversaryText.getX(), AdversaryText.getY(), 760, AdversaryText.getHeight());
        AdvTryToBreakInButton.setBounds(710, AdvTryToBreakInButton.getY(), AdvTryToBreakInButton.getWidth(), AdvTryToBreakInButton.getHeight());
        ChaetToggleButton.setBounds(805, ChaetToggleButton.getY(), ChaetToggleButton.getWidth(), ChaetToggleButton.getHeight());
        VerifierPanel.setBounds(VerifierPanel.getX(), VerifierPanel.getY(), 920-26, VerifierPanel.getHeight());        
        DetailsButton.setText("Details ->");
    } else {
        this.setMinimumSize(new Dimension(1144, this.getHeight()));
        this.setBounds(this.getX(), this.getY(), 1144, this.getHeight());
        TagPanel.setBounds(TagPanel.getX(), TagPanel.getY(), 1144-26, TagPanel.getHeight());

        AdverseryPanel.setBounds(AdverseryPanel.getX(), AdverseryPanel.getY(), 1144-26, AdverseryPanel.getHeight());
        AdvHackMsgText.setBounds(AdvHackMsgText.getX(), AdvHackMsgText.getY(), AdvHackMsgText.getWidth()+220, AdvHackMsgText.getHeight());
        AdversaryText.setBounds(AdversaryText.getX(), AdversaryText.getY(), 760+220, AdversaryText.getHeight());
        AdvTryToBreakInButton.setBounds(710+220, AdvTryToBreakInButton.getY(), AdvTryToBreakInButton.getWidth(), AdvTryToBreakInButton.getHeight());
        AdvTryToBreakInButton.setBounds(710+220, AdvTryToBreakInButton.getY(), AdvTryToBreakInButton.getWidth(), AdvTryToBreakInButton.getHeight());
        ChaetToggleButton.setBounds(805+220, ChaetToggleButton.getY(), ChaetToggleButton.getWidth(), ChaetToggleButton.getHeight());
        VerifierPanel.setBounds(VerifierPanel.getX(), VerifierPanel.getY(), 1144-26, VerifierPanel.getHeight());
        DetailsButton.setText("<- Details");
    }
    details = !details;
}//GEN-LAST:event_DetailsButtonActionPerformed

private void ChaetToggleButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_ChaetToggleButtonActionPerformed
    cheat = !cheat;
    TagARVList.setVisible(cheat);
    VerifierARVList.setVisible(cheat);
}//GEN-LAST:event_ChaetToggleButtonActionPerformed

private void GainFocus(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_GainFocus
    TagARVList.setVisible(cheat);
    VerifierARVList.setVisible(cheat);
}//GEN-LAST:event_GainFocus
    
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new MainForm().setVisible(true);
            }
        });
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JTextField AdvHackMsgText;
    private javax.swing.JButton AdvTryToBreakInButton;
    private java.awt.TextArea AdversaryText;
    private javax.swing.JPanel AdverseryPanel;
    private javax.swing.JToggleButton ChaetToggleButton;
    private javax.swing.JButton DetailsButton;
    private javax.swing.JButton StartButton;
    private javax.swing.JButton StopButton;
    private javax.swing.JList TagARVList;
    private javax.swing.JLabel TagImageLabel;
    private javax.swing.JLabel TagImageLabel1;
    private javax.swing.JLabel TagKeyEntryLabel;
    private javax.swing.JList TagLRVList;
    private javax.swing.JPanel TagPanel;
    private javax.swing.JList TagPrsList;
    private javax.swing.JLabel TagSeedLabel;
    private javax.swing.JButton TagSendButton;
    private javax.swing.JButton TagTestSessionButton;
    private java.awt.TextArea TagText;
    private javax.swing.JList TagYList;
    private javax.swing.JLabel TitleBackLabel;
    private javax.swing.JLabel TitleForeLabel;
    private javax.swing.JList VerifierARVList;
    private javax.swing.JLabel VerifierImageLabel;
    private javax.swing.JLabel VerifierKeyEntryLabel;
    private javax.swing.JList VerifierLRVList;
    private javax.swing.JLabel VerifierMsgLabel;
    private javax.swing.JPanel VerifierPanel;
    private javax.swing.JList VerifierPrsList;
    private javax.swing.JLabel VerifierSeedLabel;
    private java.awt.TextArea VerifierText;
    private javax.swing.JList VerifierZList;
    private javax.swing.JFrame jFrame1;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel100;
    private javax.swing.JLabel jLabel101;
    private javax.swing.JLabel jLabel12;
    private javax.swing.JLabel jLabel13;
    private javax.swing.JLabel jLabel14;
    private javax.swing.JLabel jLabel15;
    private javax.swing.JLabel jLabel17;
    private javax.swing.JLabel jLabel19;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JScrollPane jScrollPane10;
    private javax.swing.JScrollPane jScrollPane11;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JScrollPane jScrollPane5;
    private javax.swing.JScrollPane jScrollPane6;
    private javax.swing.JScrollPane jScrollPane7;
    private javax.swing.JScrollPane jScrollPane8;
    private javax.swing.JScrollPane jScrollPane9;
    private javax.swing.JToolBar jToolBar1;
    // End of variables declaration//GEN-END:variables
    
}

/* code for running 100 sessions and writing their results in a file.
private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {                                         
 //{
        FileOutputStream out;
        PrintStream p = null;
        
        try {
            out = new FileOutputStream("AP1.Gen.n="+n+".l="+displayBitNumber+".runs=100.txt");
            p = new PrintStream(out);
        } catch (FileNotFoundException ex) {
            Logger.getLogger(MainForm.class.getName()).log(Level.SEVERE, null, ex);
        }

        

        for (int y=0; y<100; y++) {
            ap1_gen_tag.resetIsXored();

            for (int i=0; i<n; i++) {
                TagSendButtonActionPerformed(evt);
            }
            
            boolean[] isXored = ap1_gen_tag.getIsXored();
            
            int CountUnchanged = 0;
            for (int i=0; i<n; i++) {
                if (!isXored[i]) {
                    CountUnchanged++;
                }
            }
            p.println(CountUnchanged);
        }
        
        
        p.close();
    //}
}  */                                      

/* code foe running test with different displaybit size etc.
private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {                                         
    class ttt extends Thread {
        private java.awt.event.ActionEvent evt;
        
        public ttt(java.awt.event.ActionEvent evt) {
            this.evt = evt;
        }
        
        public void run() {
            int[] ARV = RFIDCustom.createPseudoRandomArray(876, n, displayBitNumber);
            k = n;
            ap1_gen_verifier = new RFIDAP1GenerlizedVerifier(AdvVerPort, ARV,
                delayFactor, displayType, displayBitNumber,
                VerifierText, 
                VerifierARVList, VerifierLRVList,
                VerifierZList,
                VerifierKeyEntryLabel);
            adversary = new FixSeedAdversary(k, n, TagAdvPort, host, AdvVerPort, displayBitNumber,
                123, AdversaryText);        
            ap1_gen_tag = new RFIDAP1GenerlizedTag(host, TagAdvPort, ARV,
                delayFactor, displayType, displayBitNumber,
                TagText,
                TagARVList, TagLRVList, TagYList,
                TagKeyEntryLabel,
                VerifierMsgLabel);
            try {
                ttt.sleep(2000);
            } catch (InterruptedException ex) {
                Logger.getLogger(MainForm.class.getName()).log(Level.SEVERE, null, ex);
            }
            
            jButton1ActionPerformed(evt);
            
            try {
                ttt.sleep(2000);
            } catch (InterruptedException ex) {
                Logger.getLogger(MainForm.class.getName()).log(Level.SEVERE, null, ex);
            }
            
            StopButtonActionPerformed(evt);
        }
        
    }
    for (int myl=5; myl<7+1; myl++) {
    
        for (int myn=2; myn<12+1; myn++) {
            ttt tt = new ttt(evt);
            n                = myn;
            displayBitNumber = myl;
            protocol         = RFIDCustom.PROTOCOL_AP1_GENERLIZED;
            delayFactor      = 0;
            displayType      = RFIDCustom.dtBin;
            host             = "localhost";
            TagAdvPort       = 1234;
            AdvVerPort       = 4567;
            tt.start();
            try {
                tt.join();
            } catch (InterruptedException ex) {
                Logger.getLogger(MainForm.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
    }
}*/                                     
