import javax.swing.JFrame;
import javax.swing.JOptionPane;

public class SettingsDialog extends javax.swing.JDialog {

    private int    n           = 0;
    private int    delayFactor = 0;
    private String host        = null;
    private int    TagAdvPort  = 0;
    private int    AdvVerPort  = 0;
    private int    Protocol    = RFIDCustom.PROTOCOL_AP1_UNGENERLIZED;
    private int    AP1k        = 0;
    private int    AP2k        = 0;
    private int    displayType = RFIDCustom.dtDec;
    private int    BitNumber   = 4;
    
    private boolean result     = false;
    
    public SettingsDialog(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();
        this.rootPane.setDefaultButton(OKButton);
    }

    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        buttonGroup = new javax.swing.ButtonGroup();
        jPanel1 = new javax.swing.JPanel();
        jLabel2 = new javax.swing.JLabel();
        hostText = new javax.swing.JTextField();
        jLabel7 = new javax.swing.JLabel();
        TagAdvPortText = new javax.swing.JTextField();
        jLabel8 = new javax.swing.JLabel();
        AdvVerPortText = new javax.swing.JTextField();
        OKButton = new javax.swing.JButton();
        jButton1 = new javax.swing.JButton();
        jPanel2 = new javax.swing.JPanel();
        AP1Ung_RadioButton = new javax.swing.JRadioButton();
        AP1Gen_RadioButton = new javax.swing.JRadioButton();
        AP1kText = new javax.swing.JTextField();
        AP2Gen_RadioButton = new javax.swing.JRadioButton();
        AP2Ung_RadioButton = new javax.swing.JRadioButton();
        AP2kText = new javax.swing.JTextField();
        jPanel3 = new javax.swing.JPanel();
        jLabel5 = new javax.swing.JLabel();
        nText = new javax.swing.JTextField();
        DelayFactorText = new javax.swing.JTextField();
        jLabel11 = new javax.swing.JLabel();
        jLabel16 = new javax.swing.JLabel();
        jLabel12 = new javax.swing.JLabel();
        DisplayTypeComboBox = new javax.swing.JComboBox();
        jLabel6 = new javax.swing.JLabel();
        jLabel17 = new javax.swing.JLabel();
        BitNumberText = new javax.swing.JTextField();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Settings");
        setMinimumSize(new java.awt.Dimension(320, 490));
        setResizable(false);
        getContentPane().setLayout(null);

        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder("Communication"));
        jPanel1.setLayout(null);

        jLabel2.setText("Host name:");
        jPanel1.add(jLabel2);
        jLabel2.setBounds(20, 20, 70, 14);

        hostText.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        hostText.setText("localhost");
        jPanel1.add(hostText);
        hostText.setBounds(100, 20, 170, 20);

        jLabel7.setText("Tag-Adversary port:");
        jPanel1.add(jLabel7);
        jLabel7.setBounds(20, 50, 160, 14);

        TagAdvPortText.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        TagAdvPortText.setText("1234");
        jPanel1.add(TagAdvPortText);
        TagAdvPortText.setBounds(190, 50, 80, 20);

        jLabel8.setText("Adversary-Verifier port:");
        jPanel1.add(jLabel8);
        jLabel8.setBounds(20, 80, 160, 14);

        AdvVerPortText.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        AdvVerPortText.setText("4567");
        jPanel1.add(AdvVerPortText);
        AdvVerPortText.setBounds(190, 80, 80, 20);

        getContentPane().add(jPanel1);
        jPanel1.setBounds(10, 10, 290, 110);

        OKButton.setText("OK");
        OKButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                OKButtonActionPerformed(evt);
            }
        });
        getContentPane().add(OKButton);
        OKButton.setBounds(230, 420, 70, 24);

        jButton1.setText("Cancel");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });
        getContentPane().add(jButton1);
        jButton1.setBounds(130, 420, 80, 24);

        jPanel2.setBorder(javax.swing.BorderFactory.createTitledBorder("Type of simulation"));
        jPanel2.setLayout(null);

        buttonGroup.add(AP1Ung_RadioButton);
        AP1Ung_RadioButton.setSelected(true);
        AP1Ung_RadioButton.setText("AP1 with 1 private session");
        AP1Ung_RadioButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                AP1K1_Action(evt);
            }
        });
        jPanel2.add(AP1Ung_RadioButton);
        AP1Ung_RadioButton.setBounds(10, 20, 200, 23);

        buttonGroup.add(AP1Gen_RadioButton);
        AP1Gen_RadioButton.setText("AP1 with K private sessions");
        AP1Gen_RadioButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                AP1K_Action(evt);
            }
        });
        jPanel2.add(AP1Gen_RadioButton);
        AP1Gen_RadioButton.setBounds(10, 50, 200, 23);

        AP1kText.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        AP1kText.setText("4");
        jPanel2.add(AP1kText);
        AP1kText.setBounds(220, 50, 50, 20);

        buttonGroup.add(AP2Gen_RadioButton);
        AP2Gen_RadioButton.setText("AP2 with K private sessions");
        AP2Gen_RadioButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                AP2K_Action(evt);
            }
        });
        jPanel2.add(AP2Gen_RadioButton);
        AP2Gen_RadioButton.setBounds(10, 110, 200, 23);

        buttonGroup.add(AP2Ung_RadioButton);
        AP2Ung_RadioButton.setText("AP2 with 1 private session");
        AP2Ung_RadioButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                AP2K1_Action(evt);
            }
        });
        jPanel2.add(AP2Ung_RadioButton);
        AP2Ung_RadioButton.setBounds(10, 80, 200, 23);

        AP2kText.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        AP2kText.setText("4");
        jPanel2.add(AP2kText);
        AP2kText.setBounds(220, 110, 50, 20);

        getContentPane().add(jPanel2);
        jPanel2.setBounds(10, 120, 290, 140);

        jPanel3.setBorder(javax.swing.BorderFactory.createTitledBorder("General"));
        jPanel3.setLayout(null);

        jLabel5.setText("Size of ARV  (n):");
        jPanel3.add(jLabel5);
        jLabel5.setBounds(10, 20, 160, 14);

        nText.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        nText.setText("4");
        jPanel3.add(nText);
        nText.setBounds(180, 20, 90, 20);

        DelayFactorText.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        DelayFactorText.setText("300");
        jPanel3.add(DelayFactorText);
        DelayFactorText.setBounds(180, 50, 60, 20);

        jLabel11.setText("Display Delay factor:");
        jPanel3.add(jLabel11);
        jLabel11.setBounds(10, 50, 160, 14);

        jLabel16.setText("bit");
        jPanel3.add(jLabel16);
        jLabel16.setBounds(250, 114, 30, 14);

        jLabel12.setText("Display type:");
        jPanel3.add(jLabel12);
        jLabel12.setBounds(10, 80, 160, 14);

        DisplayTypeComboBox.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Decimal (default)", "Binary", "Octal", "Hexadecimal" }));
        DisplayTypeComboBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                DisplayTypeClick(evt);
            }
        });
        jPanel3.add(DisplayTypeComboBox);
        DisplayTypeComboBox.setBounds(180, 80, 90, 20);

        jLabel6.setText("Bit number to display:");
        jPanel3.add(jLabel6);
        jLabel6.setBounds(10, 110, 160, 14);

        jLabel17.setText("ms");
        jPanel3.add(jLabel17);
        jLabel17.setBounds(250, 52, 30, 14);

        BitNumberText.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        BitNumberText.setText("4");
        jPanel3.add(BitNumberText);
        BitNumberText.setBounds(180, 110, 60, 20);

        getContentPane().add(jPanel3);
        jPanel3.setBounds(10, 260, 290, 150);

        pack();
    }// </editor-fold>//GEN-END:initComponents

private void OKButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_OKButtonActionPerformed
    result = false;

    try {
        n = Integer.parseInt(nText.getText());
    } catch (NumberFormatException nfe) {
        JFrame frame = new JFrame();
        JOptionPane.showMessageDialog(frame, "\"Size of ARV\" value is non integer");
        nText.requestFocus();
        nText.selectAll();
        return;
    }
    
    try {
        delayFactor = Integer.parseInt(DelayFactorText.getText());
    } catch (NumberFormatException nfe) {
        JFrame frame = new JFrame();
        JOptionPane.showMessageDialog(frame, "\"Delay factor\" value is non integer");
        DelayFactorText.requestFocus();
        DelayFactorText.selectAll();
        return;
    }
    
    host = hostText.getText();

    try {
        TagAdvPort  = Integer.parseInt(TagAdvPortText.getText());
    } catch (NumberFormatException nfe) {
        JFrame frame = new JFrame();
        JOptionPane.showMessageDialog(frame, "\"Tag-Adversary port\" value is non integer");
        TagAdvPortText.requestFocus();
        TagAdvPortText.selectAll();
        return;
    }
    
    try {
        AdvVerPort  = Integer.parseInt(AdvVerPortText.getText());
    } catch (NumberFormatException nfe) {
        JFrame frame = new JFrame();
        JOptionPane.showMessageDialog(frame, "\"Adversary-Verifier port\" value is non integer");
        AdvVerPortText.requestFocus();
        AdvVerPortText.selectAll();
        return;
    }
    
    try {
        AP1k  = Integer.parseInt(AP1kText.getText());
    } catch (NumberFormatException nfe) {
        JFrame frame = new JFrame();
        JOptionPane.showMessageDialog(frame, "\"AP1 k\" value is non integer");
        AP1kText.requestFocus();
        AP1kText.selectAll();
        return;
    }

    try {
        AP2k  = Integer.parseInt(AP2kText.getText());
    } catch (NumberFormatException nfe) {
        JFrame frame = new JFrame();
        JOptionPane.showMessageDialog(frame, "\"AP2 k\" value is non integer");
        AP2kText.requestFocus();
        AP2kText.selectAll();
        return;
    }
    
    try {
        BitNumber  = Integer.parseInt(BitNumberText.getText());
    } catch (NumberFormatException nfe) {
        JFrame frame = new JFrame();
        JOptionPane.showMessageDialog(frame, "\"Bit Number\" value is non integer");
        BitNumberText.requestFocus();
        BitNumberText.selectAll();
        return;
    }
    if (BitNumber < 1 || BitNumber > 64) {
        JFrame frame = new JFrame();
        JOptionPane.showMessageDialog(frame, "\"Bit Number\" value is out of rang (1..64)");
        BitNumberText.requestFocus();
        BitNumberText.selectAll();
        return;        
    }        
    
    result = true;
    this.hide();
}//GEN-LAST:event_OKButtonActionPerformed

private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
    this.hide();
}//GEN-LAST:event_jButton1ActionPerformed

private void AP1K1_Action(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_AP1K1_Action
    Protocol = RFIDCustom.PROTOCOL_AP1_UNGENERLIZED;
}//GEN-LAST:event_AP1K1_Action

private void AP1K_Action(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_AP1K_Action
    Protocol = RFIDCustom.PROTOCOL_AP1_GENERLIZED;
}//GEN-LAST:event_AP1K_Action

private void AP2K1_Action(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_AP2K1_Action
    Protocol = RFIDCustom.PROTOCOL_AP2_UNGENERLIZED;
}//GEN-LAST:event_AP2K1_Action

private void AP2K_Action(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_AP2K_Action
    Protocol = RFIDCustom.PROTOCOL_AP2_GENERLIZED;
}//GEN-LAST:event_AP2K_Action

private void DisplayTypeClick(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_DisplayTypeClick
    displayType = DisplayTypeComboBox.getSelectedIndex();
}//GEN-LAST:event_DisplayTypeClick

    public int get_n() {
        return n;
    }

    public int get_delayFactor() {
        return delayFactor;
    }

    public String get_host() {
        return host;
    }
    
    public int get_TagAdvPort() {
        return TagAdvPort;
    }

    public int get_AdvVerPort() {
        return AdvVerPort;
    }
    
    public int get_Protocol() {
        return Protocol;
    }
    
    public boolean get_result() {
        return result;
    }
    
    public int get_AP1k() {
        return AP1k;
    }
    
    public int get_AP2k() {
        return AP2k;
    }
    
    public int get_DisplayType() {
        return displayType;
    }

    public int get_BitNumber() {
        return BitNumber;
    }
       
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                SettingsDialog dialog = new SettingsDialog(new javax.swing.JFrame(), true);
                dialog.addWindowListener(new java.awt.event.WindowAdapter() {
                    public void windowClosing(java.awt.event.WindowEvent e) {
                        System.exit(0);
                    }
                });
                dialog.setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JRadioButton AP1Gen_RadioButton;
    private javax.swing.JRadioButton AP1Ung_RadioButton;
    private javax.swing.JTextField AP1kText;
    private javax.swing.JRadioButton AP2Gen_RadioButton;
    private javax.swing.JRadioButton AP2Ung_RadioButton;
    private javax.swing.JTextField AP2kText;
    private javax.swing.JTextField AdvVerPortText;
    private javax.swing.JTextField BitNumberText;
    private javax.swing.JTextField DelayFactorText;
    private javax.swing.JComboBox DisplayTypeComboBox;
    private javax.swing.JButton OKButton;
    private javax.swing.JTextField TagAdvPortText;
    private javax.swing.ButtonGroup buttonGroup;
    private javax.swing.JTextField hostText;
    private javax.swing.JButton jButton1;
    private javax.swing.JLabel jLabel11;
    private javax.swing.JLabel jLabel12;
    private javax.swing.JLabel jLabel16;
    private javax.swing.JLabel jLabel17;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JTextField nText;
    // End of variables declaration//GEN-END:variables

}
